Your search did not match any results.

JavaScript/jQuery Charts - Side-by-Side Stacked Bar

This demo shows the side-by-side stacked bar series that allows you to visualize data as bars stacked in different groups. This series type is useful when you compare values of an individual series with the total values of groups.

www.wikipedia.org
Backend API
$(() => { $('#chart').dxChart({ dataSource, commonSeriesSettings: { argumentField: 'state', type: 'stackedBar', }, series: [ { valueField: 'maleyoung', name: 'Male: 0-14', stack: 'male' }, { valueField: 'malemiddle', name: 'Male: 15-64', stack: 'male' }, { valueField: 'maleolder', name: 'Male: 65 and older', stack: 'male' }, { valueField: 'femaleyoung', name: 'Female: 0-14', stack: 'female' }, { valueField: 'femalemiddle', name: 'Female: 15-64', stack: 'female' }, { valueField: 'femaleolder', name: 'Female: 65 and older', stack: 'female' }, ], legend: { horizontalAlignment: 'right', position: 'inside', border: { visible: true }, columnCount: 2, customizeItems(items) { const sortedItems = []; items.forEach((item) => { const startIndex = item.series.stack === 'male' ? 0 : 3; sortedItems.splice(startIndex, 0, item); }); return sortedItems; }, }, valueAxis: { title: { text: 'Populations, millions', }, }, title: 'Population: Age Structure', export: { enabled: true, }, tooltip: { enabled: true, }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.8"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="chart"></div> </div> </body> </html>
#chart { height: 440px; }
const dataSource = [{ state: 'USA', maleyoung: 29.956, malemiddle: 90.354, maleolder: 14.472, femaleyoung: 28.597, femalemiddle: 91.827, femaleolder: 20.362, }, { state: 'Brazil', maleyoung: 25.607, malemiddle: 55.793, maleolder: 3.727, femaleyoung: 24.67, femalemiddle: 57.598, femaleolder: 5.462, }, { state: 'Russia', maleyoung: 13.493, malemiddle: 48.983, maleolder: 5.802, femaleyoung: 12.971, femalemiddle: 52.14, femaleolder: 12.61, }, { state: 'Japan', maleyoung: 9.575, malemiddle: 43.363, maleolder: 9.024, femaleyoung: 9.105, femalemiddle: 42.98, femaleolder: 12.501, }, { state: 'Mexico', maleyoung: 17.306, malemiddle: 30.223, maleolder: 1.927, femaleyoung: 16.632, femalemiddle: 31.868, femaleolder: 2.391, }, { state: 'Germany', maleyoung: 6.679, malemiddle: 28.638, maleolder: 5.133, femaleyoung: 6.333, femalemiddle: 27.693, femaleolder: 8.318, }, { state: 'United Kindom', maleyoung: 5.816, malemiddle: 19.622, maleolder: 3.864, femaleyoung: 5.519, femalemiddle: 19.228, femaleolder: 5.459, }];

Bind Chart to Data

The side-by-side stacked bar chart contains series with the same argument field. In this demo, the data source array consists of the objects with the same field structure. Assign the state field to the argumentField property of the commonSeriesSettings object to specify the common argument for the series. Then, define the series array of objects. In each object, specify the valueField property and use the stack property to group the series in stacks depending on the stack property values.

Customize Side-By-Side Stacked Bar Chart

Customize Chart Legend

Use the verticalAlignment and horizontalAlignment properties of the legend object to specify the legend layout.

The customizeLegend function allows you to change the order, text, and visibility of legend items. This demo uses the array.splice method in the customizeItems function to sort the legend items. If you want to customize the legend border, use properties collected in the border object.

To distribute all legend items between multiple columns (in a vertically-oriented legend) or rows (in a horizontally-oriented legend), specify the columnCount or rowCount property, respectively.

Configure Tooltips

To configure tooltips in the chart, use the tooltip object. To enable the tooltips, assign true to the enabled property of this object.

Export Chart

To allow users to export your side-by-side stacked bar chart into a PNG, JPEG, PDF, and SVG file or print the chart, set the export.enabled property to true. Since the export functionality is enabled in this demo, you can click the hamburger button in the chart to invoke a drop-down menu with export and print commands.

<template>
<DxChart
id="chart"
:data-source="dataSource"
title="Population: Age Structure"
>
<DxCommonSeriesSettings
argument-field="state"
type="stackedbar"
/>
<DxValueAxis>
<DxTitle text="Populations, millions"/>
</DxValueAxis>
<DxSeries
value-field="maleyoung"
name="Male: 0-14"
stack="male"
/>
<DxSeries
value-field="malemiddle"
name="Male: 15-64"
stack="male"
/>
<DxSeries
value-field="maleolder"
name="Male: 65 and older"
stack="male"
/>
<DxSeries
value-field="femaleyoung"
name="Female: 0-14"
stack="female"
/>
<DxSeries
value-field="femalemiddle"
name="Female: 15-64"
stack="female"
/>
<DxSeries
value-field="femaleolder"
name="Female: 65 and older"
stack="female"
/>
<DxLegend
:customize-items="customizeItems"
:column-count="2"
position="inside"
horizontal-alignment="right"
>
<DxBorder :visible="true"/>
</DxLegend>
<DxExport :enabled="true"/>
<DxTooltip :enabled="true"/>
</DxChart>
</template>
<script setup lang="ts">
import {
DxChart,
DxSeries,
DxCommonSeriesSettings,
DxValueAxis,
DxTitle,
DxLegend,
DxBorder,
DxExport,
DxTooltip,
} from 'devextreme-vue/chart';
import type { LegendItem } from 'devextreme-vue/common/charts';
import service from './data.ts';
const dataSource = service.getMaleAgeData();
function customizeItems(items: Array<LegendItem>): Array<LegendItem> {
const sortedItems: Array<LegendItem> = [];
items.forEach((item) => {
const startIndex = (item.series as Record<string, any>)?.stack === 'male' ? 0 : 3;
sortedItems.splice(startIndex, 0, item);
});
return sortedItems;
}
</script>
<style>
#chart {
height: 440px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
const maleAgeData = [{
state: 'USA',
maleyoung: 29.956,
malemiddle: 90.354,
maleolder: 14.472,
femaleyoung: 28.597,
femalemiddle: 91.827,
femaleolder: 20.362,
}, {
state: 'Brazil',
maleyoung: 25.607,
malemiddle: 55.793,
maleolder: 3.727,
femaleyoung: 24.67,
femalemiddle: 57.598,
femaleolder: 5.462,
}, {
state: 'Russia',
maleyoung: 13.493,
malemiddle: 48.983,
maleolder: 5.802,
femaleyoung: 12.971,
femalemiddle: 52.14,
femaleolder: 12.61,
}, {
state: 'Japan',
maleyoung: 9.575,
malemiddle: 43.363,
maleolder: 9.024,
femaleyoung: 9.105,
femalemiddle: 42.98,
femaleolder: 12.501,
}, {
state: 'Mexico',
maleyoung: 17.306,
malemiddle: 30.223,
maleolder: 1.927,
femaleyoung: 16.632,
femalemiddle: 31.868,
femaleolder: 2.391,
}, {
state: 'Germany',
maleyoung: 6.679,
malemiddle: 28.638,
maleolder: 5.133,
femaleyoung: 6.333,
femalemiddle: 27.693,
femaleolder: 8.318,
}, {
state: 'United Kindom',
maleyoung: 5.816,
malemiddle: 19.622,
maleolder: 3.864,
femaleyoung: 5.519,
femalemiddle: 19.228,
femaleolder: 5.459,
}];
export default {
getMaleAgeData() {
return maleAgeData;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React from 'react';
import {
Chart,
Series,
CommonSeriesSettings,
Legend,
ValueAxis,
Title,
Export,
Tooltip,
Border,
} from 'devextreme-react/chart';
import type { LegendItem as LegendItemBase } from 'devextreme/common/charts';
import { maleAgeData } from './data.ts';
type LegendItem = LegendItemBase & { series?: { stack?: string } };
function customizeItems(items: LegendItem[]): LegendItem[] {
const sortedItems: LegendItem[] = [];
items.forEach((item: LegendItem): void => {
const startIndex = item.series?.stack === 'male' ? 0 : 3;
sortedItems.splice(startIndex, 0, item);
});
return sortedItems;
}
function App() {
return (
<Chart
id="chart"
title="Population: Age Structure"
dataSource={maleAgeData}
>
<CommonSeriesSettings argumentField="state" type="stackedbar" />
<Series
valueField="maleyoung"
name="Male: 0-14"
stack="male"
/>
<Series
valueField="malemiddle"
name="Male: 15-64"
stack="male"
/>
<Series
valueField="maleolder"
name="Male: 65 and older"
stack="male"
/>
<Series
valueField="femaleyoung"
name="Female: 0-14"
stack="female"
/>
<Series
valueField="femalemiddle"
name="Female: 15-64"
stack="female"
/>
<Series
valueField="femaleolder"
name="Female: 65 and older"
stack="female"
/>
<ValueAxis>
<Title text="Populations, millions" />
</ValueAxis>
<Legend position="inside"
columnCount={2}
customizeItems={customizeItems}
horizontalAlignment="right">
<Border visible={true} />
</Legend>
<Export enabled={true} />
<Tooltip enabled={true} />
</Chart>
);
}
export default App;
import React from 'react';
import {
Chart,
Series,
CommonSeriesSettings,
Legend,
ValueAxis,
Title,
Export,
Tooltip,
Border,
} from 'devextreme-react/chart';
import { maleAgeData } from './data.js';
function customizeItems(items) {
const sortedItems = [];
items.forEach((item) => {
const startIndex = item.series?.stack === 'male' ? 0 : 3;
sortedItems.splice(startIndex, 0, item);
});
return sortedItems;
}
function App() {
return (
<Chart
id="chart"
title="Population: Age Structure"
dataSource={maleAgeData}
>
<CommonSeriesSettings
argumentField="state"
type="stackedbar"
/>
<Series
valueField="maleyoung"
name="Male: 0-14"
stack="male"
/>
<Series
valueField="malemiddle"
name="Male: 15-64"
stack="male"
/>
<Series
valueField="maleolder"
name="Male: 65 and older"
stack="male"
/>
<Series
valueField="femaleyoung"
name="Female: 0-14"
stack="female"
/>
<Series
valueField="femalemiddle"
name="Female: 15-64"
stack="female"
/>
<Series
valueField="femaleolder"
name="Female: 65 and older"
stack="female"
/>
<ValueAxis>
<Title text="Populations, millions" />
</ValueAxis>
<Legend
position="inside"
columnCount={2}
customizeItems={customizeItems}
horizontalAlignment="right"
>
<Border visible={true} />
</Legend>
<Export enabled={true} />
<Tooltip enabled={true} />
</Chart>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { MaleAgeData } from './types.ts';
export const maleAgeData: MaleAgeData[] = [{
state: 'USA',
maleyoung: 29.956,
malemiddle: 90.354,
maleolder: 14.472,
femaleyoung: 28.597,
femalemiddle: 91.827,
femaleolder: 20.362,
}, {
state: 'Brazil',
maleyoung: 25.607,
malemiddle: 55.793,
maleolder: 3.727,
femaleyoung: 24.67,
femalemiddle: 57.598,
femaleolder: 5.462,
}, {
state: 'Russia',
maleyoung: 13.493,
malemiddle: 48.983,
maleolder: 5.802,
femaleyoung: 12.971,
femalemiddle: 52.14,
femaleolder: 12.61,
}, {
state: 'Japan',
maleyoung: 9.575,
malemiddle: 43.363,
maleolder: 9.024,
femaleyoung: 9.105,
femalemiddle: 42.98,
femaleolder: 12.501,
}, {
state: 'Mexico',
maleyoung: 17.306,
malemiddle: 30.223,
maleolder: 1.927,
femaleyoung: 16.632,
femalemiddle: 31.868,
femaleolder: 2.391,
}, {
state: 'Germany',
maleyoung: 6.679,
malemiddle: 28.638,
maleolder: 5.133,
femaleyoung: 6.333,
femalemiddle: 27.693,
femaleolder: 8.318,
}, {
state: 'United Kindom',
maleyoung: 5.816,
malemiddle: 19.622,
maleolder: 3.864,
femaleyoung: 5.519,
femalemiddle: 19.228,
femaleolder: 5.459,
}];
export type MaleAgeData = {
state: string;
maleyoung: number;
malemiddle: number;
maleolder: number;
femaleyoung: number;
femalemiddle: number;
femaleolder: number;
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const maleAgeData = [
{
state: 'USA',
maleyoung: 29.956,
malemiddle: 90.354,
maleolder: 14.472,
femaleyoung: 28.597,
femalemiddle: 91.827,
femaleolder: 20.362,
},
{
state: 'Brazil',
maleyoung: 25.607,
malemiddle: 55.793,
maleolder: 3.727,
femaleyoung: 24.67,
femalemiddle: 57.598,
femaleolder: 5.462,
},
{
state: 'Russia',
maleyoung: 13.493,
malemiddle: 48.983,
maleolder: 5.802,
femaleyoung: 12.971,
femalemiddle: 52.14,
femaleolder: 12.61,
},
{
state: 'Japan',
maleyoung: 9.575,
malemiddle: 43.363,
maleolder: 9.024,
femaleyoung: 9.105,
femalemiddle: 42.98,
femaleolder: 12.501,
},
{
state: 'Mexico',
maleyoung: 17.306,
malemiddle: 30.223,
maleolder: 1.927,
femaleyoung: 16.632,
femalemiddle: 31.868,
femaleolder: 2.391,
},
{
state: 'Germany',
maleyoung: 6.679,
malemiddle: 28.638,
maleolder: 5.133,
femaleyoung: 6.333,
femalemiddle: 27.693,
femaleolder: 8.318,
},
{
state: 'United Kindom',
maleyoung: 5.816,
malemiddle: 19.622,
maleolder: 3.864,
femaleyoung: 5.519,
femalemiddle: 19.228,
femaleolder: 5.459,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}

<dx-chart
id="chart"
[dataSource]="populationData"
title="Population: Age Structure"
>
<dxi-chart-series valueField="maleyoung" name="Male: 0-14" stack="male">
</dxi-chart-series>
<dxi-chart-series valueField="malemiddle" name="Male: 15-64" stack="male">
</dxi-chart-series>
<dxi-chart-series
valueField="maleolder"
name="Male: 65 and older"
stack="male"
>
</dxi-chart-series>
<dxi-chart-series valueField="femaleyoung" name="Female: 0-14" stack="female">
</dxi-chart-series>
<dxi-chart-series
valueField="femalemiddle"
name="Female: 15-64"
stack="female"
>
</dxi-chart-series>
<dxi-chart-series
valueField="femaleolder"
name="Female: 65 and older"
stack="female"
>
</dxi-chart-series>
<dxi-chart-value-axis>
<dxo-chart-title text="Populations, millions"></dxo-chart-title>
</dxi-chart-value-axis>
<dxo-chart-common-series-settings argumentField="state" type="stackedBar">
</dxo-chart-common-series-settings>
<dxo-chart-legend
horizontalAlignment="right"
columnCount="2"
[customizeItems]="customizeItems"
position="inside"
>
<dxo-chart-border [visible]="true"></dxo-chart-border>
</dxo-chart-legend>
<dxo-chart-export [enabled]="true"></dxo-chart-export>
<dxo-chart-tooltip [enabled]="true"></dxo-chart-tooltip>
</dx-chart>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxChartModule } from 'devextreme-angular';
import { Population, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxChartModule,
],
})
export class AppComponent {
populationData: Population[];
constructor(service: Service) {
this.populationData = service.getPopulationData();
}
customizeItems(items) {
const sortedItems = [];
items.forEach((item) => {
const startIndex = item.series.stack === 'male' ? 0 : 3;
sortedItems.splice(startIndex, 0, item);
});
return sortedItems;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #chart {
height: 440px;
}
import { Injectable } from '@angular/core';
export class Population {
state: string;
maleyoung: number;
malemiddle: number;
maleolder: number;
femaleyoung: number;
femalemiddle: number;
femaleolder: number;
}
const populationData: Population[] = [{
state: 'USA',
maleyoung: 29.956,
malemiddle: 90.354,
maleolder: 14.472,
femaleyoung: 28.597,
femalemiddle: 91.827,
femaleolder: 20.362,
}, {
state: 'Brazil',
maleyoung: 25.607,
malemiddle: 55.793,
maleolder: 3.727,
femaleyoung: 24.67,
femalemiddle: 57.598,
femaleolder: 5.462,
}, {
state: 'Russia',
maleyoung: 13.493,
malemiddle: 48.983,
maleolder: 5.802,
femaleyoung: 12.971,
femalemiddle: 52.14,
femaleolder: 12.61,
}, {
state: 'Japan',
maleyoung: 9.575,
malemiddle: 43.363,
maleolder: 9.024,
femaleyoung: 9.105,
femalemiddle: 42.98,
femaleolder: 12.501,
}, {
state: 'Mexico',
maleyoung: 17.306,
malemiddle: 30.223,
maleolder: 1.927,
femaleyoung: 16.632,
femalemiddle: 31.868,
femaleolder: 2.391,
}, {
state: 'Germany',
maleyoung: 6.679,
malemiddle: 28.638,
maleolder: 5.133,
femaleyoung: 6.333,
femalemiddle: 27.693,
femaleolder: 8.318,
}, {
state: 'United Kindom',
maleyoung: 5.816,
malemiddle: 19.622,
maleolder: 3.864,
femaleyoung: 5.519,
femalemiddle: 19.228,
femaleolder: 5.459,
}];
@Injectable()
export class Service {
getPopulationData(): Population[] {
return populationData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>